Page MenuHomePhabricator

[release][analyzer] Add 13.0.0 release notes
ClosedPublic

Authored by Szelethus on Aug 30 2021, 4:30 AM.

Details

Summary

Scrolled through the log, and whatever felt like a good patch to highlight from a user's standpoint got into the notes!

git log llvmorg-13-init..llvmorg-13.0.0-rc1 --oneline -- clang/lib/StaticAnalyzer/ clang/include/clang/StaticAnalyzer/ clang/lib/Analysis/ clang/include/clang/Analysis/

If you think I forgot to add anybody, or have neglected to add an important patch, let me know!

Diff Detail

Unit TestsFailed

TimeTest
0 msx64 windows > Clang.CodeGen/aarch64-sve-intrinsics::acle_sve_st1b.c
shell parser error on: ": 'RUN: at line 3'; c:\\ws\\w7\\llvm-project\\premerge-checks\\build\\bin\\clang.exe -cc1 -internal-isystem c:\\ws\\w7\\llvm-project\\premerge-checks\\build\\lib\\clang\\14.0.0\\include -nostdsysteminc -triple aarch64-none-linux-gnu -target-feature +sve -fallow-half-arguments-and-returns -S -O1 -Werror -o - -emit-llvm C:\\ws\\w7\\llvm-project\\premerge-checks\\clang\\test\\CodeGen\\aarch64-sve-intrinsics\\acle_sve_st1b.c |& c:\\ws\\w7\\llvm-project\\premerge-checks\\build\\bin\\filecheck.exe C:\\ws\\w7\\llvm-project\\premerge-checks\\clang\\test\\CodeGen\\aarch64-sve-intrinsics\\acle_sve_st1b.c"
10 msx64 windows > Clang.CodeGen/aarch64-sve-intrinsics::acle_sve_st1h.c
shell parser error on: ": 'RUN: at line 3'; c:\\ws\\w7\\llvm-project\\premerge-checks\\build\\bin\\clang.exe -cc1 -internal-isystem c:\\ws\\w7\\llvm-project\\premerge-checks\\build\\lib\\clang\\14.0.0\\include -nostdsysteminc -triple aarch64-none-linux-gnu -target-feature +sve -fallow-half-arguments-and-returns -S -O1 -Werror -o - -emit-llvm C:\\ws\\w7\\llvm-project\\premerge-checks\\clang\\test\\CodeGen\\aarch64-sve-intrinsics\\acle_sve_st1h.c |& c:\\ws\\w7\\llvm-project\\premerge-checks\\build\\bin\\filecheck.exe C:\\ws\\w7\\llvm-project\\premerge-checks\\clang\\test\\CodeGen\\aarch64-sve-intrinsics\\acle_sve_st1h.c"
0 msx64 windows > Clang.CodeGen/aarch64-sve-intrinsics::acle_sve_st1w.c
shell parser error on: ": 'RUN: at line 3'; c:\\ws\\w7\\llvm-project\\premerge-checks\\build\\bin\\clang.exe -cc1 -internal-isystem c:\\ws\\w7\\llvm-project\\premerge-checks\\build\\lib\\clang\\14.0.0\\include -nostdsysteminc -triple aarch64-none-linux-gnu -target-feature +sve -fallow-half-arguments-and-returns -S -O1 -Werror -o - -emit-llvm C:\\ws\\w7\\llvm-project\\premerge-checks\\clang\\test\\CodeGen\\aarch64-sve-intrinsics\\acle_sve_st1w.c |& c:\\ws\\w7\\llvm-project\\premerge-checks\\build\\bin\\filecheck.exe C:\\ws\\w7\\llvm-project\\premerge-checks\\clang\\test\\CodeGen\\aarch64-sve-intrinsics\\acle_sve_st1w.c"

Event Timeline

Szelethus created this revision.Aug 30 2021, 4:30 AM
Szelethus requested review of this revision.Aug 30 2021, 4:30 AM
Szelethus added inline comments.Aug 30 2021, 4:33 AM
clang/docs/ReleaseNotes.rst
294

Oops, should add this comment before commiting.

.. 2407eb08a574 [analyzer] Update static analyzer to be support sarif-html

Maybe a couple other noteworthy commits:
efa7df1682c2859dabe3646ee7dc01e68629417f: better R-value tracking.
aa454dda2eed4e71081bc57b1f32dfce2486b177: fixing the modeling of std::bit_cast<>.
cad9b7f708e2b2d19d7890494980c5e427d6d4ea: Print time taken to analyze each function
9cca5c1391d637b5500ada646cf136ddb38254a3: Make checker silencing work for non-pathsensitive bug reports. (It might be valuable to highlight for other vendors.)

There must have been a couple of patches about std::unique_ptr<> as well.

But I'm fine with the current description. I think it's on the point.

clang/docs/ReleaseNotes.rst
315

abd -> and

Here is one more related to HTML diagnostics:
rG9e02f58780ab8734e5d27a0138bd477d18ae64a1 Highlight arrows for currently selected event

Szelethus updated this revision to Diff 370561.Sep 3 2021, 5:43 AM

Fixes according to reviewer comments, cheers!

Maybe a couple other noteworthy commits:
efa7df1682c2859dabe3646ee7dc01e68629417f: better R-value tracking.
aa454dda2eed4e71081bc57b1f32dfce2486b177: fixing the modeling of std::bit_cast<>.

I added a bit more text to the final "various fixes" point, thanks! I didn't dedicate a new point for them though, because although we know how meaningful they are, in the grand scheme of things, I don't think they are as "flashy" from an end user's perspective. Even if they greatly increase confidence in the tool, and are harder to fix then writing a simple checker ;)

cad9b7f708e2b2d19d7890494980c5e427d6d4ea: Print time taken to analyze each function

Good idea!

9cca5c1391d637b5500ada646cf136ddb38254a3: Make checker silencing work for non-pathsensitive bug reports. (It might be valuable to highlight for other vendors.)

We're yet to iron out checker silencing, or finish its discussion before introducing it to the set of function intended for end users. I wouldn't like to advertise it before that happens.

Here is one more related to HTML diagnostics:
rG9e02f58780ab8734e5d27a0138bd477d18ae64a1 Highlight arrows for currently selected event

Good idea!

I suppose that the SmartPtrModelling patches from GSoC this year shouldn't be added since they only involve an alpha checker.

whisperity added inline comments.Sep 3 2021, 5:54 AM
clang/docs/ReleaseNotes.rst
300–304

Why is the commit prefix different between these two?

Szelethus updated this revision to Diff 370564.Sep 3 2021, 5:56 AM

I suppose that the SmartPtrModelling patches from GSoC this year shouldn't be added since they only involve an alpha checker.

It would be a real shame if they went unrecognized! Added! (only those patches though that landed before the rc2 tag, which always happens right in the middle of GSoC projects.)

Szelethus marked an inline comment as done.Sep 3 2021, 5:58 AM
clang/docs/ReleaseNotes.rst
300–304

I copied them from the reviewer comments. Mind that this file is reset each release, and will likely never be read, so I figured it doesn't matter much :^) Its mostly there for me to double check whether I summarized the patch correctly.

I suppose that the SmartPtrModelling patches from GSoC this year shouldn't be added since they only involve an alpha checker.

Actually, you also patched the enabled-by-default modeling part of smart pointers, haven't you? Those definitely deserve their mention!

I suppose that the SmartPtrModelling patches from GSoC this year shouldn't be added since they only involve an alpha checker.

Actually, you also patched the enabled-by-default modeling part of smart pointers, haven't you? Those definitely deserve their mention!

Well, a part of it is in 0cd98bef1b6f [analyzer] Handle std::swap for std::unique_ptr.
The other major portion is in destructor modelling, and this patch hasn't landed yet.

Gonna land this in a day or two, regardless of whether its accepted! Please take a look if you have anything to object to!

Szelethus accepted this revision.Sep 23 2021, 3:09 AM
This revision is now accepted and ready to land.Sep 23 2021, 3:09 AM